package cz.upol.net;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class MTServerExample {
	
	private static volatile boolean stopServer = false;
	
	public static void main(String[] args) throws IOException {
		ServerSocket srvSocket = new ServerSocket(4242);
		
		while (!stopServer) {
			System.out.println("Waiting for a client");
			Socket clientSocket = srvSocket.accept();
			Thread serverThread = new ServerThread(clientSocket);
			serverThread.start();
		}
		System.out.println("So long!");
		srvSocket.close();
	}
	
	private static class ServerThread extends Thread {
		
		private Socket clientSocket;

		public ServerThread(Socket clientSocket) {
			this.clientSocket = clientSocket;
		}
		
		public void run() {
			try (BufferedReader rd = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
			     BufferedWriter wr = new BufferedWriter(new OutputStreamWriter(clientSocket.getOutputStream()))) {

				while (true) {
					String line = rd.readLine();
					System.out.println("Request: " + line);
					if (line.equalsIgnoreCase("quit"))
						break;
					if (line.equalsIgnoreCase("stopServer")) {
						stopServer = true;
						break;
					}

					String resp = line.toUpperCase();
					System.out.println("Response: " + resp);
					wr.write(resp);
					wr.write('\n');
					wr.flush();
				}
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				try {
					clientSocket.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
